﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using PdfSharp.Pdf;
using PdfSharp.Drawing;
using System.Drawing;

namespace pdfSharp
{
    class Program
    {
        static void Main(string[] args)
        {
            PdfDocument pdfDocument = new PdfDocument();
            PdfPage pdfPage = new PdfPage();
            pdfPage.Size = PdfSharp.PageSize.A0;
            pdfPage.Orientation = PdfSharp.PageOrientation.Landscape;
            pdfDocument.Pages.Add(pdfPage);
            PdfSharp.Drawing.XGraphics pdfGraphics = PdfSharp.Drawing.XGraphics.FromPdfPage(pdfDocument.Pages[0]);

            // draw grid first
            DrawGridOnPdfSurface(pdfGraphics);

            RectangleF gridBounds = new RectangleF(-0.5000005f, -0.5000005f, 1190f, 841.9999f);
            
            // if I draw some figure the grid will appear.Why??? (Uncomment dawn row)
            //pdfGraphics.DrawEllipse(XBrushes.Red, new Rectangle(0, 0, 30, 30));

            pdfGraphics.DrawRectangle(XPens.Black, XBrushes.Transparent, gridBounds);
 
            string someFileName = "C:\\Users\\Yosif\\Desktop\\imageToPdf.pdf";

            pdfDocument.Save(someFileName);
        }

        public static void DrawGridOnPdfSurface(PdfSharp.Drawing.XGraphics pdfGraphics)
        {
            RectangleF gridBounds = new RectangleF(-0.5000005f, -0.5000005f, 1190f, 841.9999f);
            float gridStepX = 10;
            float gridStepY = 10;

            if (gridStepX < 1 || gridStepY < 1 || gridBounds.Width < 1 || gridBounds.Height < 1)
                return;

            gridBounds.X = (float)(Math.Truncate(gridBounds.Left / gridStepX) * gridStepX);
            gridBounds.Width = (float)(Math.Truncate(gridBounds.Width / gridStepX) * gridStepX);
            gridBounds.Y = (float)(Math.Truncate(gridBounds.Y / gridStepY) * gridStepY);
            gridBounds.Height = (float)(Math.Truncate(gridBounds.Height / gridStepY) * gridStepY);

            // Use one pen to draw the grid.
            Pen gridPen = new Pen(Color.LightGray, 0);

            for (var x = gridBounds.Left; x <= gridBounds.Right; x += gridStepX)
            {
                if (x < gridBounds.X)
                    continue;

                pdfGraphics.DrawLine(gridPen, x, gridBounds.Top, x, gridBounds.Bottom);
            }

            for (var y = gridBounds.Top; y <= gridBounds.Bottom; y += gridStepY)
            {
                if (y < gridBounds.Y)
                    continue;

                pdfGraphics.DrawLine(gridPen, gridBounds.Left, y, gridBounds.Right, y);
            }

        }
    }
}
